<?php
/*
Plugin Name: Title Links
Version: 1.1
Plugin URI: http://blog.cfrq.net/chk/archives/2006/08/02/title-links-plugintitle-links-plugin/
Description: links post titles that appear in entries
Author: Harald Koch
Author URI: http://blog.cfrq.net/chk/

Copyright (c) 2006
Released under the GPL license
http://www.gnu.org/licenses/gpl.txt

    This file is part of WordPress.
    WordPress is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


function titlelinks_get_subs() {

	$subs = array();

	$posts = get_posts('numberposts=999999');
	foreach ($posts as $post) {
		$link_names = get_post_meta($post->ID, 'link_names', true);
		$pl = get_permalink($post->ID);

		$parts = Array();
		array_push($parts, $post->post_title);
		if (preg_match_all('@\[([^\]]+)\]@', $link_names, $matches) > 0) {
			foreach ($matches[1] as $match) {
				$match = preg_replace("/'/", "&#8217;", $match);
				array_push($parts, $match);
			}
		}
		$key = implode('|', $parts);

		$subs[$key] = $pl;
	}

	return $subs;
}

function titlelinks_do_subs($text) {
	global $titlelinks_titlelinks;

	if ( empty($titlelinks_titlelinks) ) {
		$titlelinks_titlelinks = titlelinks_get_subs();
	}

	$text = " $text ";
	foreach ($titlelinks_titlelinks as $pattern => $link) {
		$text = preg_replace("@(?!<[^<>]*?)(?<![?./&])\b($pattern)\b(?!:)(?![^<>]*?>)@imsU","<a href=\"$link\">$1</a>" , $text);
	}

	return trim ($text);
}

add_filter('the_content', 'titlelinks_do_subs', 10);
add_filter('comment_text', 'titlelinks_do_subs', 10);

?>
